Attribute VB_Name = "RgnButtonApi"
Option Explicit

'\\ --[RgnButtonApi]------------------------------------------------
'\\ Demonstrates the use of GetRegionData and ExtCreateDC functions
'\\ ----------------------------------------------------------------
Private RegionBytes() As Byte


Public Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long

Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Type XFORM
    eM11 As Double
    eM12 As Double
    eM21 As Double
    eM22 As Double
    eDx As Double
    eDy As Double
End Type
Public Enum RegionTypes
    COMPLEXREGION = 3
    SIMPLEREGION = 2
    NULLREGION = 1
    ERRORAPI = 0
End Enum
Type RGNDATAHEADER
    dwSize As Long
    iType As RegionTypes
    nCount As Long
    nRgnSize As Long
    rcBound As RECT
End Type
Type RGNDATA
    rdh As RGNDATAHEADER
    'buffer(1 To 1000) As RECT
End Type

Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type
Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors() As RGBQUAD
End Type



Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Type BITMAP '14 bytes
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Public Declare Function GetRegionDataBytes Lib "gdi32" Alias "GetRegionDataA" (ByVal hRgn As Long, ByVal dwCount As Long, lpRgnData As Byte) As Long
Public Declare Function ExtCreateRegion Lib "gdi32" (lpXform As Any, ByVal nCount As Long, lpRgnData As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, lpSource As Any, ByVal Length As Long)
Private Declare Sub CopyMemoryByte Lib "kernel32" Alias "RtlMoveMemory" (Destination As Byte, ByVal lpSource As Long, ByVal Length As Long)
Private Declare Sub CopyMemoryLong Lib "kernel32" Alias "RtlMoveMemory" (Destination As Long, ByVal lpSource As Long, ByVal Length As Long)

Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long

Private Declare Function GetWorldTransform Lib "gdi32" (ByVal hdc As Long, lpXform As XFORM) As Long
Private Declare Function GetRegionData Lib "gdi32" (ByVal hRgn As Long, ByVal dwCount As Long, lpRgnData As RGNDATA) As Long

Private Const BI_RGB = 0&
Private Const DIB_PAL_COLORS = 1 '  color table in palette indices
Private Const DIB_RGB_COLORS = 0 '  color table in RGBs

Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalReAlloc Lib "kernel32" (ByVal hMem As Long, ByVal dwBytes As Long, ByVal wFlags As Long) As Long
Private Declare Function GlobalSize Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long

Private Const GMEM_MOVEABLE = &H2

Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

'\\ Slow method....
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Const RGN_OR = 2

'\\ API Calls to pass on WM_ message to previous windows proc...
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'\\ Get Window Long Indexes...
Public Enum enGetWindowLong
    GWL_EXSTYLE = (-20)
    GWL_HINSTANCE = (-6)
    GWL_HWNDPARENT = (-8)
    GWL_ID = (-12)
    GWL_STYLE = (-16)
    GWL_USERDATA = (-21)
    GWL_WNDPROC = (-4)
End Enum
'\\ Window specific information
Private Declare Function GetWindowLongApi Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLongApi Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public mcolButtons As Collection

'\\ Window message constants - for WndProc(wMsg).
Public Enum WindowMessages
 WM_ACTIVATE = &H6             '(LOWORD) wp = WA_, (HIWORD) > 0 if minimized, lp =hwnd
 WM_ACTIVATEAPP = &H1C
 WM_ASKCBFORMATNAME = &H30C
 WM_CANCELJOURNAL = &H4B
 WM_CANCELMODE = &H1F
 WM_CAPTURECHANGED = &H1F       'wParam = 0, lParam = New capture hWnd
 WM_CAPTURECHANGED_R = &H215
 WM_CHANGECBCHAIN = &H30D
 WM_CHAR = &H102
 WM_CHARTOITEM = &H2F
 WM_CHILDACTIVATE = &H22
 WM_CHOOSEFONT_GETLOGFONT = (&H400 + 1)
 WM_CHOOSEFONT_SETFLAGS = (&H400 + 102)
 WM_CHOOSEFONT_SETLOGFONT = (&H400 + 101)
 WM_CLEAR = &H303
 WM_CLOSE = &H10
 WM_COMMAND = &H111
 WM_COMPACTING = &H41
 WM_COMPAREITEM = &H39
 WM_CONVERTREQUESTEX = &H108
 WM_COPY = &H301
 WM_COPYDATA = &H4A
 WM_CREATE = &H1
 WM_CTLCOLORBTN = &H135
 WM_CTLCOLORDLG = &H136
 WM_CTLCOLOREDIT = &H133
 WM_CTLCOLORLISTBOX = &H134
 WM_CTLCOLORMSGBOX = &H132
 WM_CTLCOLORSCROLLBAR = &H137
 WM_CTLCOLORSTATIC = &H138
 WM_CUT = &H300
 WM_DDE_ACK = (&H3E0 + 4)
 WM_DDE_ADVISE = (&H3E0 + 2)
 WM_DDE_DATA = (&H3E0 + 5)
 WM_DDE_EXECUTE = (&H3E0 + 8)
 WM_DDE_FIRST = &H3E0
 WM_DDE_INITIATE = &H3E0
 WM_DDE_LAST = (&H3E0 + 8)
 WM_DDE_POKE = (&H3E0 + 7)
 WM_DDE_REQUEST = (&H3E0 + 6)
 WM_DDE_TERMINATE = (&H3E0 + 1)
 WM_DDE_UNADVISE = (&H3E0 + 3)
 WM_DEADCHAR = &H103
 WM_DELETEITEM = &H2D
 WM_DESTROY = &H2
 WM_DESTROYCLIPBOARD = &H307
 WM_DEVICECHANGE = &H219 '\\ Version 4 and beyond
 WM_DEVMODECHANGE = &H1B
 WM_DRAWCLIPBOARD = &H308
 WM_DRAWITEM = &H2B
 WM_DROPFILES = &H233
 WM_ENABLE = &HA
 WM_ENDSESSION = &H16
 WM_ENTERIDLE = &H121
 WM_ENTERSIZEMOVE = &H231
 WM_ENTERMENULOOP = &H211
 WM_ERASEBKGND = &H14  'wParam = 0, lParam = hDC of window.  Return 0 if intercepted...
 WM_EXITMENULOOP = &H212
 WM_EXITSIZEMOVE = &H232
 WM_FONTCHANGE = &H1D
 WM_GETDLGCODE = &H87
 WM_GETFONT = &H31
 WM_GETHOTKEY = &H33
 WM_GETMINMAXINFO = &H24
 WM_GETTEXT = &HD
 WM_GETTEXTLENGTH = &HE
 WM_HOTKEY = &H312
 WM_HSCROLL = &H114
 WM_HSCROLLCLIPBOARD = &H30E
 WM_ICONERASEBKGND = &H27
 WM_IME_CHAR = &H286
 WM_IME_COMPOSITION = &H10F
 WM_IME_COMPOSITIONFULL = &H284
 WM_IME_CONTROL = &H283
 WM_IME_ENDCOMPOSITION = &H10E
 WM_IME_KEYDOWN = &H290
 WM_IME_KEYLAST = &H10F
 WM_IME_KEYUP = &H291
 WM_IME_NOTIFY = &H282
 WM_IME_SELECT = &H285
 WM_IME_SETCONTEXT = &H281
 WM_IME_STARTCOMPOSITION = &H10D
 WM_INITDIALOG = &H110
 WM_INITMENU = &H116
 WM_INITMENUPOPUP = &H117
 WM_KEYDOWN = &H100
 WM_KEYUP = &H101
 WM_KILLFOCUS = &H8 'wParam = hWnd of window about to lose focus.
 WM_LBUTTONDBLCLK = &H203
 WM_LBUTTONDOWN = &H201
 WM_LBUTTONUP = &H202
 WM_MBUTTONDBLCLK = &H209
 WM_MBUTTONDOWN = &H207
 WM_MBUTTONUP = &H208
 WM_MDIACTIVATE = &H222
 WM_MDICASCADE = &H227
 WM_MDICREATE = &H220
 WM_MDIDESTROY = &H221
 WM_MDIGETACTIVE = &H229
 WM_MDIICONARRANGE = &H228
 WM_MDIMAXIMIZE = &H225
 WM_MDINEXT = &H224
 WM_MDIREFRESHMENU = &H234
 WM_MDIRESTORE = &H223
 WM_MDISETMENU = &H230
 WM_MDITILE = &H226
 WM_MEASUREITEM = &H2C
 WM_MENUCHAR = &H120
 WM_MENUSELECT = &H11F
 WM_MENURBUTTONUP = &H122 '\\ Version 5 and beyond
 WM_MENUDRAG = &H123      '\\ Version 5 and beyond
 WM_MENUGETOBJECT = &H124 '\\ Version 5 and beyond
 WM_MENUCOMMAND = &H126   '\\ Version 5 and beyond
 WM_MOUSEACTIVATE = &H21
 WM_MOUSEHOVER = &H2A1    '\\ Version 4 and beyond
 WM_MOUSELEAVE = &H2A3    '\\ Version 4 and beyond
 WM_MOUSEMOVE = &H200
 WM_MOUSEWHEEL = &H20A    '\\ Version 4 and beyond
 WM_MOVE = &H3
 WM_MOVING = &H216
 WM_NCACTIVATE = &H86
 WM_NCCALCSIZE = &H83
 WM_NCCREATE = &H81
 WM_NCDESTROY = &H82
 WM_NCHITTEST = &H84
 WM_NCLBUTTONDBLCLK = &HA3
 WM_NCLBUTTONDOWN = &HA1
 WM_NCLBUTTONUP = &HA2
 WM_NCMBUTTONDBLCLK = &HA9
 WM_NCMBUTTONDOWN = &HA7
 WM_NCMBUTTONUP = &HA8
 WM_NCMOUSEMOVE = &HA0
 WM_NCPAINT = &H85
 WM_NCRBUTTONDBLCLK = &HA6
 WM_NCRBUTTONDOWN = &HA4
 WM_NCRBUTTONUP = &HA5
 WM_NEXTDLGCTL = &H28
 WM_NEXTMENU = &H213
 WM_NULL = &H0
 WM_PAINT = &HF
 WM_PAINTCLIPBOARD = &H309
 WM_PAINTICON = &H26
 WM_PALETTECHANGED = &H311
 WM_PALETTEISCHANGING = &H310
 WM_PARENTNOTIFY = &H210
 WM_PASTE = &H302
 WM_PENWINFIRST = &H380
 WM_PENWINLAST = &H38F
 WM_POWER = &H48
 WM_POWERBROADCAST = &H218
 WM_PRINT = &H317       '\\ Version 4 and beyond
 WM_PRINTCLIENT = &H318 '\\ Version 4 and beyond
 WM_PSD_ENVSTAMPRECT = (&H400 + 5)
 WM_PSD_FULLPAGERECT = (&H400 + 1)
 WM_PSD_GREEKTEXTRECT = (&H400 + 4)
 WM_PSD_MARGINRECT = (&H400 + 3)
 WM_PSD_MINMARGINRECT = (&H400 + 2)
 WM_PSD_PAGESETUPDLG = (&H400)
 WM_PSD_YAFULLPAGERECT = (&H400 + 6)
 WM_QUERYDRAGICON = &H37
 WM_QUERYENDSESSION = &H11
 WM_QUERYNEWPALETTE = &H30F
 WM_QUERYOPEN = &H13
 WM_QUEUESYNC = &H23
 WM_QUIT = &H12
 WM_RBUTTONDBLCLK = &H206
 WM_RBUTTONDOWN = &H204
 WM_RBUTTONUP = &H205
 WM_RENDERALLFORMATS = &H306
 WM_RENDERFORMAT = &H305
 WM_SETCURSOR = &H20
 WM_SETFOCUS = &H7
 WM_SETFONT = &H30
 WM_SETHOTKEY = &H32
 WM_SETREDRAW = &HB
 WM_SETTEXT = &HC
 WM_SETTINGCHANGE = &H1A
 WM_SHOWWINDOW = &H18
 WM_SIZE = &H5
 WM_SIZING = &H214
 WM_SIZECLIPBOARD = &H30B
 WM_SPOOLERSTATUS = &H2A
 WM_SYSCHAR = &H106
 WM_SYSCOLORCHANGE = &H15
 WM_SYSCOMMAND = &H112
 WM_SYSDEADCHAR = &H107
 WM_SYSKEYDOWN = &H104
 WM_SYSKEYUP = &H105
 WM_TIMECHANGE = &H1E
 WM_TIMER = &H113
 WM_UNDO = &H304
 WM_USER = &H400
 WM_VKEYTOITEM = &H2E
 WM_VSCROLL = &H115
 WM_VSCROLLCLIPBOARD = &H30A
 WM_WINDOWPOSCHANGED = &H47
 WM_WINDOWPOSCHANGING = &H46
 WM_WININICHANGE = &H1A
End Enum

'\\ Before WM_MOUSEHOVER and WM_MOUSELEAVE messages can be generated for
'\\ a window, the message tracking must be enabled on that window
Public Enum TrackMouseEvents
     TME_HOVER = &H1
     TME_LEAVE = &H2
     TME_QUERY = &H40000000
     TME_CANCEL = &H80000000
End Enum

Private Type TRACKMOUSESTRUCT
    cbSize As Long
    dwFlags As Long '\\ TrackMouseEvents
    hwndTrack As Long '\\ Target window
    dwHoverTime As Long '\\ Mouse hover timeout in milliseconds
End Type

Private Declare Function TrackMouseEvent Lib "user32" (lpTrackMouseStruct As TRACKMOUSESTRUCT) As Long

Public Function StopSubclassingButton(ByVal btn As RgnButtonCtrl)

If btn.OldWndproc <> 0 Then
    Call SetWindowLongApi(btn.hwnd, GWL_WNDPROC, btn.OldWndproc)
    Call mcolButtons.Remove("HWND:" & btn.hwnd)
End If

End Function

Public Function SubclassButton(ByVal btn As RgnButtonCtrl)

Dim mOldWndProc

If mcolButtons Is Nothing Then
    Set mcolButtons = New Collection
End If
'\\ If it isn't already subclassed, do so...
If btn.OldWndproc = 0 Then
    mcolButtons.Add btn, "HWND:" & btn.hwnd
    btn.OldWndproc = SetWindowLongApi(btn.hwnd, GWL_WNDPROC, AddressOf VB_WindowProc)
End If

End Function


'\\ --[VB_WindowProc]-------------------------------------------------------------------
'\\ 'typedef LRESULT (CALLBACK* WNDPROC)(HWND, UINT, WPARAM, LPARAM);
'\\ Parameters:
'\\   hwnd - window handle receiving message
'\\   wMsg - The window message (WM_..etc.)
'\\   wParam - First message parameter
'\\   lParam - Second message parameter
'\\ Note:
'\\    When subclassing a window proc using this, set the eventhandler's
'\\    hOldWndProc property to the window's previous window proc address.
'\\ ----------------------------------------------------------------------------------------
'\\ (c) 2001 - Merrion Computing.  All rights  to use, reproduce or publish this code reserved
'\\ Please check http://www.merrioncomputing.com for updates.
'\\ ----------------------------------------------------------------------------------------
Public Function VB_WindowProc(ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

On Local Error Resume Next
Dim lret As Long
Dim tsThis As TRACKMOUSESTRUCT
Dim btnThis As RgnButtonCtrl

If Not mcolButtons Is Nothing Then
    Set btnThis = mcolButtons.Item("HWND:" & hwnd)
    If btnThis.Enabled Then
        If wMsg = WM_MOUSEHOVER Then
            btnThis.ButtonState = State_Hover
        End If
        
        If wMsg = WM_MOUSELEAVE Or wMsg = WM_LBUTTONUP Then
            btnThis.ButtonState = State_Up
        End If
        
        If wMsg = WM_MOUSEACTIVATE Or wMsg = WM_MOUSEMOVE Then
            '\\ Start the mouse tracking
            With tsThis
                .cbSize = Len(tsThis)
                .hwndTrack = hwnd
                .dwFlags = (TME_HOVER Or TME_LEAVE)
            End With
            lret = TrackMouseEvent(tsThis)
        End If
        
        If wMsg = WM_LBUTTONDOWN Then
            btnThis.ButtonState = State_Down
        End If
    End If
    lret = CallWindowProc(btnThis.OldWndproc, hwnd, wMsg, wParam, lParam)
End If

VB_WindowProc = lret

End Function
'\\ --[RegionFromBitmap]------------------------------------------------------------------------
'\\ Creates the region that corresponds to the given bitmap where the mask colour
'\\ is considered external to the region.
'\\ --------------------------------------------------------------------------------------------
'\\ (c) 2001 Merrion Computing Ltd.  All rights reserved
Public Function RegionFromBitmap(ByVal ctl As RgnButtonCtrl, ByVal BITMAP As Picture, ByVal MaskColour As Long) As Long

Dim lret As Long

Dim hdcThis As Long

Dim biThis As BITMAPINFO
Dim bmThis As BITMAP
Dim colourBuffer() As RGBQUAD
Dim lIndex As Long, lItem As Long
Dim colourmask As New ApiColour
Dim nullXForm As XFORM

Dim bInRegion As Boolean
Dim numRects As Long

Dim rgnThis As RGNDATA
Dim lRow As Long
Dim lColumn As Long

Dim buffer() As Byte
Dim lByteSize As Long
Dim hData As Long

Dim rgnTemp As Long
Dim rectBuffer() As RECT

If Not BITMAP Is Nothing Then
    hdcThis = CreateCompatibleDC(ctl.hdc)
    colourmask.ColourRef = MaskColour
    lret = GetObject(BITMAP.Handle, Len(bmThis), bmThis)
    If Err.LastDllError = 0 Then
        With biThis.bmiHeader
            .biBitCount = 32
            .biCompression = BI_RGB
            .biPlanes = 1
            .biSize = Len(biThis.bmiHeader)
            .biWidth = bmThis.bmWidth
            .biHeight = bmThis.bmHeight
            ReDim Preserve colourBuffer(1 To (.biWidth * .biHeight)) As RGBQUAD
        End With
        
        lret = GetDIBits(hdcThis, BITMAP.Handle, 0, bmThis.bmHeight, colourBuffer(1), biThis, DIB_RGB_COLORS)
        '\\ Note: NT4 quirk - bitmap must be read upside down
        For lRow = (biThis.bmiHeader.biHeight - 1) To 0 Step -1
            For lColumn = 0 To (biThis.bmiHeader.biWidth - 1)
                lIndex = (lColumn + (lRow * biThis.bmiHeader.biWidth)) + 1
                '\\ If at the end of a column, close any rectangle...
                If lColumn = 0 Then
                    bInRegion = False
                End If
               If (colourmask.Red = colourBuffer(lIndex).rgbRed) And (colourmask.Blue = colourBuffer(lIndex).rgbBlue) And (colourmask.Green = colourBuffer(lIndex).rgbGreen) Then
                   '\\ Colour matches mask colour.
                   bInRegion = False
               Else
                   '\\ Colour is not mask colour
                   If bInRegion Then
                       rectBuffer(numRects).Right = lColumn + 1
                   Else
                       '\\ Start a new region rectangle...
                       numRects = numRects + 1
                       ReDim Preserve rectBuffer(1 To numRects) As RECT
                       'If numRects > 1 Then
                       '     For lIndex = numRects To 2 Step -1
                       '        Call SwapRects(rectBuffer(lIndex), rectBuffer(lIndex - 1))
                       '     Next lIndex
                       'End If
                       With rectBuffer(numRects)
                           .Left = lColumn
                           .Top = (biThis.bmiHeader.biHeight) - lRow
                           .Bottom = .Top + 1
                           .Right = .Left + 1
                       End With
                       bInRegion = True
                   End If
               End If
            Next lColumn
        Next lRow
        '\\ Now create a region object from this data
        With rgnThis.rdh
            .iType = 1
            .dwSize = Len(rgnThis.rdh)
            .nRgnSize = .dwSize + (numRects * Len(rectBuffer(1)))
            .nCount = numRects
            .rcBound.Left = 0
            .rcBound.Top = 0
            .rcBound.Right = bmThis.bmWidth
            .rcBound.Bottom = bmThis.bmHeight
        End With
        
        If Err.LastDllError = 0 Then
            lByteSize = LenB(rgnThis)
            lByteSize = lByteSize + (numRects * Len(rectBuffer(1))) - 1
            '\\ copy the region data to the buffer
            ReDim buffer(lByteSize) As Byte
            CopyMemoryByte buffer(0), VarPtr(rgnThis.rdh), Len(rgnThis.rdh)
            CopyMemoryByte buffer(Len(rgnThis.rdh) - 1), VarPtr(rectBuffer(1)), numRects * Len(rectBuffer(1))
            
            For lIndex = 1 To UBound(rectBuffer)
                With rectBuffer(lIndex)
                    Debug.Print "( " & .Left & " , " & .Top & " , " & .Right & " , " & .Bottom & ")"
                End With
            Next lIndex
            
            'lret = ExtCreateRegion(ByVal 0&, lByteSize, ByVal VarPtr(buffer(0)))
            'If Err.LastDllError = 0 Then
            '    If lret <> 0 Then
            '        RegionFromBitmap = lret
            '    Else
            '        '\\ Have to resort to the slow method....
                    With rectBuffer(1)
                        lret = CreateRectRgn(.Left, .Top, .Right, .Bottom)
                    End With
                    For lIndex = 2 To UBound(rectBuffer)
                        With rectBuffer(lIndex)
                            rgnTemp = CreateRectRgn(.Left, .Top, .Right, .Bottom)
                            Call CombineRgn(lret, lret, rgnTemp, RGN_OR)
                            DeleteObject rgnTemp
                        End With
                    Next lIndex
                    RegionFromBitmap = lret
            '    End If
            'End If
            'If hData <> 0 Then
            '    GlobalFree hData
            'End If
        End If
    End If
    If hdcThis <> 0 Then
        Call DeleteDC(hdcThis)
    End If
End If

End Function

Public Function MakeLong(ByVal LoWord As Integer, ByVal HiWord As Integer) As Long

MakeLong = Val("&H" & PadString(Hex(HiWord), 4, "0") & PadString(Hex(LoWord), 4, "0"))

End Function

Public Function MakeInt(ByVal LoByte As Byte, ByVal hiByte As Byte) As Integer

MakeInt = Val("&H" & PadString(Hex(hiByte), 2, "0") & PadString(Hex(LoByte), 2, "0"))

End Function

'\\ --[LoWord]-----------------------------------------------------------------------------
'\\ Returns the low word component of a long value
'\\ Parameters:
'\\   dw - The long of which we need the LoWord
'\\
'\\ ----------------------------------------------------------------------------------------
'\\ (c) 2001 - Merrion Computing.  All rights  to use, reproduce or publish this code reserved
'\\ Please check http://www.merrioncomputing.com for updates.
'\\ ----------------------------------------------------------------------------------------
Public Function LoWord(dw As Long) As Integer
  If dw And &H8000& Then
      LoWord = &H8000 Or (dw And &H7FFF&)
   Else
      LoWord = dw And &HFFFF&
   End If
End Function

'\\ --[LoByte]-----------------------------------------------------------------------------
'\\ Returns the low byte component of an integer value
'\\ Parameters:
'\\   w - The integer of which we need the loWord
'\\
'\\ ----------------------------------------------------------------------------------------
'\\ (c) 2001 - Merrion Computing.  All rights  to use, reproduce or publish this code reserved
'\\ Please check http://www.merrioncomputing.com for updates.
'\\ ----------------------------------------------------------------------------------------
Public Function LoByte(w As Integer) As Byte
 LoByte = w And &HFF
End Function

'\\ --[HiByte]-----------------------------------------------------------------------------
'\\ Returns the high byte component of an integer
'\\ Parameters:
'\\   w - The integer of which we need the HiByte
'\\
'\\ ----------------------------------------------------------------------------------------
'\\ (c) 2001 - Merrion Computing.  All rights  to use, reproduce or publish this code reserved
'\\ Please check http://www.merrioncomputing.com for updates.
'\\ ----------------------------------------------------------------------------------------
Public Function hiByte(ByVal w As Integer) As Byte
   If w And &H8000 Then
      hiByte = &H80 Or ((w And &H7FFF) \ &HFF)
   Else
      hiByte = w \ 256
    End If
End Function

'\\ --[HiWord]-----------------------------------------------------------------------------
'\\ Returns the high word component of a long value
'\\ Parameters:
'\\   dw - The long of which we need the HiWord
'\\
'\\ ----------------------------------------------------------------------------------------
'\\ (c) 2001 - Merrion Computing.  All rights  to use, reproduce or publish this code reserved
'\\ Please check http://www.merrioncomputing.com for updates.
'\\ ----------------------------------------------------------------------------------------
Public Function HiWord(dw As Long) As Integer
 If dw And &H80000000 Then
      HiWord = (dw \ 65535) - 1
 Else
    HiWord = dw \ 65535
 End If
End Function

Public Function PadString(ByVal sIn As String, ByVal Length As Long, ByVal Char As String)

If Len(sIn) >= Length Then
    PadString = Left$(sIn, Length)
Else
    PadString = String$(Length - Len(sIn), Char) & sIn
End If

End Function

Public Sub CopyFromHandle(ByVal hMemHandle As Long, mydata() As Byte)

Dim lret As Long
Dim lPtr As Long
Dim myDataSize As Long

lret = GlobalSize(hMemHandle)
If lret > 0 Then
    myDataSize = lret
    lPtr = GlobalLock(hMemHandle)
    If lPtr > 0 Then
        ReDim mydata(0 To myDataSize - 1) As Byte
        CopyMemory mydata(0), ByVal lPtr, myDataSize
        Call GlobalUnlock(hMemHandle)
    End If
End If

End Sub

Public Sub CopyToHandle(ByVal hMemHandle As Long, mydata() As Byte)

Dim lSize As Long
Dim lPtr As Long


lSize = GlobalSize(hMemHandle)
'\\ Don't attempt to copy if zero size...
If lSize > 0 Then
    lPtr = GlobalLock(hMemHandle)
    If lPtr > 0 Then
        CopyMemory ByVal lPtr, mydata(0), lSize
        Call GlobalUnlock(hMemHandle)
    End If
End If


End Sub
Private Sub SwapRects(rectUp As RECT, rectDown As RECT)

Dim rctemp As RECT

With rctemp
    .Left = rectUp.Left
    .Right = rectUp.Right
    .Top = rectUp.Top
    .Bottom = rectUp.Bottom
End With

With rectUp
    .Left = rectDown.Left
    .Right = rectDown.Right
    .Top = rectDown.Top
    .Bottom = rectDown.Bottom
End With

With rectDown
    .Left = rctemp.Left
    .Right = rctemp.Right
    .Top = rctemp.Top
    .Bottom = rctemp.Bottom
End With

End Sub


