VERSION 5.00
Begin VB.UserControl RgnButtonCtrl 
   ClientHeight    =   645
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1260
   ScaleHeight     =   43
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   84
   ToolboxBitmap   =   "RgnButtonCtrl.ctx":0000
End
Attribute VB_Name = "RgnButtonCtrl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit


'Default Property Values:
Const m_def_ToolTipText = ""
Const m_def_MaskColour = &H0

'Property Variables:
Dim m_hWnd As Long
Dim m_ToolTipText As String
'Dim m_ToolTipText As String
Dim m_MaskColour As Long
Dim m_Enabled As Boolean

'\\ --[Four bitmaps for the button]-----------------------------------
Dim m_UpPicture As Picture
Dim m_DownPicture As Picture
Dim m_HoverPicture As Picture
Dim m_DisabledPicture As Picture

'\\ --[Three regions from the three bitmaps]---------------------------
Dim m_rgnButtonUp As Long
Dim m_rgnButtonDown As Long
Dim m_rgnButtonHover As Long
Dim m_rgnButtonDisabled As Long

'Event Declarations:
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
'Event Click()
'Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)


Private Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long

Public Enum ButtonStates
    State_Up = 1
    State_Down = 2
    State_Hover = 3
    State_Disabled = 4
End Enum

Private m_ButtonState As ButtonStates

'\\ Variable for use in subclassing multiple instances of the button control
Private mOldWndProc As Long

Friend Property Let ButtonState(ByVal newState As ButtonStates)

Dim lret As Long

If newState <> m_ButtonState Then
    m_ButtonState = newState
    Select Case m_ButtonState
    Case State_Up
        If Not m_UpPicture Is Nothing Then
            Set UserControl.Picture = m_UpPicture
        End If
        If m_rgnButtonUp <> 0 Then
            lret = SetWindowRgn(UserControl.hwnd, m_rgnButtonUp, True)
        End If
    Case State_Down
        If Not m_DownPicture Is Nothing Then
            Set UserControl.Picture = m_DownPicture
        End If
        If m_rgnButtonDown <> 0 Then
            lret = SetWindowRgn(UserControl.hwnd, m_rgnButtonDown, True)
        End If
    Case State_Hover
        If Not m_HoverPicture Is Nothing Then
            Set UserControl.Picture = m_HoverPicture
        End If
        If m_rgnButtonHover <> 0 Then
            lret = SetWindowRgn(UserControl.hwnd, m_rgnButtonHover, True)
        End If
    Case State_Disabled
        If Not m_DisabledPicture Is Nothing Then
            Set UserControl.Picture = m_DisabledPicture
        End If
        If m_rgnButtonDisabled <> 0 Then
            lret = SetWindowRgn(UserControl.hwnd, m_rgnButtonDisabled, True)
        End If
    End Select
End If

End Property


Public Property Set DisabledPicture(ByVal New_DisabledPicture As Picture)
    If Ambient.UserMode Then Err.Raise 382
    Set m_DisabledPicture = New_DisabledPicture
    PropertyChanged "DisabledPicture"
End Property

Public Property Get DisabledPicture() As Picture

    Set DisabledPicture = m_DisabledPicture
    
End Property

Public Property Let Enabled(ByVal newEnable As Boolean)

Dim lret As Long

m_Enabled = newEnable
PropertyChanged "Enabled"
If m_Enabled Then
    Me.ButtonState = State_Up
Else
    Me.ButtonState = State_Disabled
End If

End Property

Public Property Get Enabled() As Boolean

    Enabled = m_Enabled
    
End Property

Friend Property Get hdc() As Long

    hdc = UserControl.hdc
    
End Property

Public Sub Initialise()

End Sub

Public Property Let MaskColour(ByVal newColour As Long)

    m_MaskColour = newColour
    PropertyChanged "MaskColour"
    
End Property

Public Property Get MaskColour() As Long

    MaskColour = m_MaskColour
    
End Property
'
'Public Property Get ToolTipText() As String
'    ToolTipText = m_ToolTipText
'End Property
'
'Public Property Let ToolTipText(ByVal New_ToolTipText As String)
'    m_ToolTipText = New_ToolTipText
'    PropertyChanged "ToolTipText"
'End Property

Friend Property Let OldWndproc(ByVal newOldWndproc As Long)

    mOldWndProc = newOldWndproc
    
End Property

Friend Property Get OldWndproc() As Long

    OldWndproc = mOldWndProc
    
End Property

Public Property Get UpPicture() As Picture
Attribute UpPicture.VB_Description = "The picture of the button when the button is up and the mouse is not hovering over it"
    Set UpPicture = m_UpPicture
End Property

Public Property Set UpPicture(ByVal New_UpPicture As Picture)
    If Ambient.UserMode Then Err.Raise 382
    Set m_UpPicture = New_UpPicture
    PropertyChanged "UpPicture"
End Property

Public Property Get DownPicture() As Picture
Attribute DownPicture.VB_Description = "The picture of th ebutton when it is down"
    Set DownPicture = m_DownPicture
End Property

Public Property Set DownPicture(ByVal New_DownPicture As Picture)
    If Ambient.UserMode Then Err.Raise 382
    Set m_DownPicture = New_DownPicture
    PropertyChanged "DownPicture"
End Property

Public Property Get HoverPicture() As Picture
Attribute HoverPicture.VB_Description = "The picture of the button when the mouse is hovering over it"
    Set HoverPicture = m_HoverPicture
End Property

Public Property Set HoverPicture(ByVal New_HoverPicture As Picture)
    If Ambient.UserMode Then Err.Raise 382
    Set m_HoverPicture = New_HoverPicture
    PropertyChanged "HoverPicture"
End Property
'
'Private Sub UserControl_Click()
'    RaiseEvent Click
'End Sub

Private Sub UserControl_Initialize()

'If Ambient.UserMode Then
    Call RgnButtonApi.SubclassButton(Me)
'End If

End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()

    m_ToolTipText = m_def_ToolTipText
    '\\ Default the pictures to be empty
    Set m_UpPicture = LoadPicture("")
    Set m_DownPicture = LoadPicture("")
    Set m_HoverPicture = LoadPicture("")
    Set m_DisabledPicture = LoadPicture("")
    '\\ Default the mask colour to black
    m_MaskColour = m_def_MaskColour
    m_Enabled = True
    
End Sub
    
'End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    With PropBag
        UserControl.AutoRedraw = .ReadProperty("AutoRedraw", False)
        UserControl.BackColor = .ReadProperty("BackColor", &H8000000F)
        UserControl.BackStyle = .ReadProperty("BackStyle", 1)
        UserControl.BorderStyle = .ReadProperty("BorderStyle", 0)
        UserControl.MousePointer = .ReadProperty("MousePointer", 0)
        UserControl.ScaleHeight = .ReadProperty("ScaleHeight", 43)
        UserControl.ScaleLeft = .ReadProperty("ScaleLeft", 0)
        UserControl.ScaleMode = .ReadProperty("ScaleMode", 3)
        UserControl.ScaleTop = .ReadProperty("ScaleTop", 0)
        UserControl.ScaleWidth = .ReadProperty("ScaleWidth", 84)
        m_ToolTipText = .ReadProperty("ToolTipText", m_def_ToolTipText)
        Set m_UpPicture = .ReadProperty("UpPicture", Nothing)
        Set m_DownPicture = .ReadProperty("DownPicture", Nothing)
        Set m_HoverPicture = .ReadProperty("HoverPicture", Nothing)
        Set m_DisabledPicture = .ReadProperty("DisabledPicture", Nothing)
        m_MaskColour = .ReadProperty("MaskColour", m_def_MaskColour)
        m_Enabled = .ReadProperty("Enabled", False)
    End With
    
    '\\ Create the regions from the bitmaps....
    m_rgnButtonUp = RegionFromBitmap(Me, m_UpPicture, m_MaskColour)
    m_rgnButtonDown = RegionFromBitmap(Me, m_DownPicture, m_MaskColour)
    m_rgnButtonHover = RegionFromBitmap(Me, m_HoverPicture, m_MaskColour)
    m_rgnButtonDisabled = RegionFromBitmap(Me, m_DisabledPicture, m_MaskColour)
    

End Sub

Private Sub UserControl_Terminate()


Call RgnButtonApi.StopSubclassingButton(Me)


End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    With PropBag
        Call .WriteProperty("ToolTipText", m_ToolTipText, m_def_ToolTipText)
        Call .WriteProperty("UpPicture", m_UpPicture, Nothing)
        Call .WriteProperty("DownPicture", m_DownPicture, Nothing)
        Call .WriteProperty("HoverPicture", m_HoverPicture, Nothing)
        Call .WriteProperty("DisabledPicture", m_DisabledPicture, Nothing)
        Call .WriteProperty("MaskColour", m_MaskColour, m_def_MaskColour)
        Call .WriteProperty("AutoRedraw", UserControl.AutoRedraw, False)
        Call .WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
        Call .WriteProperty("BackStyle", UserControl.BackStyle, 1)
        Call .WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
        Call .WriteProperty("MousePointer", UserControl.MousePointer, 0)
        Call .WriteProperty("ScaleHeight", UserControl.ScaleHeight, 43)
        Call .WriteProperty("ScaleLeft", UserControl.ScaleLeft, 0)
        Call .WriteProperty("ScaleMode", UserControl.ScaleMode, 3)
        Call .WriteProperty("ScaleTop", UserControl.ScaleTop, 0)
        Call .WriteProperty("ScaleWidth", UserControl.ScaleWidth, 84)
        Call .WriteProperty("Enabled", m_Enabled, False)
    End With
    

End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,AutoRedraw
Public Property Get AutoRedraw() As Boolean
Attribute AutoRedraw.VB_Description = "Returns/sets the output from a graphics method to a persistent bitmap."
    AutoRedraw = UserControl.AutoRedraw
End Property

Public Property Let AutoRedraw(ByVal New_AutoRedraw As Boolean)
    UserControl.AutoRedraw() = New_AutoRedraw
    PropertyChanged "AutoRedraw"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackStyle
Public Property Get BackStyle() As Integer
Attribute BackStyle.VB_Description = "Indicates whether a Label or the background of a Shape is transparent or opaque."
    BackStyle = UserControl.BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As Integer)
    UserControl.BackStyle() = New_BackStyle
    PropertyChanged "BackStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,MousePointer
Public Property Get MousePointer() As Integer
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As Integer)
    UserControl.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ScaleHeight
Public Property Get ScaleHeight() As Single
Attribute ScaleHeight.VB_Description = "Returns/sets the number of units for the vertical measurement of an object's interior."
    ScaleHeight = UserControl.ScaleHeight
End Property

Public Property Let ScaleHeight(ByVal New_ScaleHeight As Single)
    UserControl.ScaleHeight() = New_ScaleHeight
    PropertyChanged "ScaleHeight"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ScaleLeft
Public Property Get ScaleLeft() As Single
Attribute ScaleLeft.VB_Description = "Returns/sets the horizontal coordinates for the left edges of an object."
    ScaleLeft = UserControl.ScaleLeft
End Property

Public Property Let ScaleLeft(ByVal New_ScaleLeft As Single)
    UserControl.ScaleLeft() = New_ScaleLeft
    PropertyChanged "ScaleLeft"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ScaleMode
Public Property Get ScaleMode() As Integer
Attribute ScaleMode.VB_Description = "Returns/sets a value indicating measurement units for object coordinates when using graphics methods or positioning controls."
    ScaleMode = UserControl.ScaleMode
End Property

Public Property Let ScaleMode(ByVal New_ScaleMode As Integer)
    UserControl.ScaleMode() = New_ScaleMode
    PropertyChanged "ScaleMode"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ScaleTop
Public Property Get ScaleTop() As Single
Attribute ScaleTop.VB_Description = "Returns/sets the vertical coordinates for the top edges of an object."
    ScaleTop = UserControl.ScaleTop
End Property

Public Property Let ScaleTop(ByVal New_ScaleTop As Single)
    UserControl.ScaleTop() = New_ScaleTop
    PropertyChanged "ScaleTop"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ScaleWidth
Public Property Get ScaleWidth() As Single
Attribute ScaleWidth.VB_Description = "Returns/sets the number of units for the horizontal measurement of an object's interior."
    ScaleWidth = UserControl.ScaleWidth
End Property

Public Property Let ScaleWidth(ByVal New_ScaleWidth As Single)
    UserControl.ScaleWidth() = New_ScaleWidth
    PropertyChanged "ScaleWidth"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ScaleX
Public Function ScaleX(Width As Single, Optional FromScale As Variant, Optional ToScale As Variant) As Single
Attribute ScaleX.VB_Description = "Converts the value for the width of a Form, PictureBox, or Printer from one unit of measure to another."
    ScaleX = UserControl.ScaleX(Width, FromScale, ToScale)
End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ScaleY
Public Function ScaleY(Height As Single, Optional FromScale As Variant, Optional ToScale As Variant) As Single
Attribute ScaleY.VB_Description = "Converts the value for the height of a Form, PictureBox, or Printer from one unit of measure to another."
    ScaleY = UserControl.ScaleY(Height, FromScale, ToScale)
End Function

Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Returns/sets the text displayed when the mouse is paused over the control."
    ToolTipText = m_ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
    m_ToolTipText = New_ToolTipText
    PropertyChanged "ToolTipText"
End Property

Public Property Get hwnd() As Long
Attribute hwnd.VB_Description = "Returns a handle (from Microsoft Windows) to an object's window."
    hwnd = UserControl.hwnd
End Property



